import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { HjmChoices, HjmChoicesParam } from './model';

/**
 * 分页查询选择题选项
 */
export async function pageHjmChoices(params: HjmChoicesParam) {
  const res = await request.get<ApiResult<PageResult<HjmChoices>>>(
    '/hjm/hjm-choices/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询选择题选项列表
 */
export async function listHjmChoices(params?: HjmChoicesParam) {
  const res = await request.get<ApiResult<HjmChoices[]>>(
    '/hjm/hjm-choices',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加选择题选项
 */
export async function addHjmChoices(data: HjmChoices) {
  const res = await request.post<ApiResult<unknown>>(
    '/hjm/hjm-choices',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改选择题选项
 */
export async function updateHjmChoices(data: HjmChoices) {
  const res = await request.put<ApiResult<unknown>>(
    '/hjm/hjm-choices',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除选择题选项
 */
export async function removeHjmChoices(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/hjm/hjm-choices/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除选择题选项
 */
export async function removeBatchHjmChoices(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/hjm/hjm-choices/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询选择题选项
 */
export async function getHjmChoices(id: number) {
  const res = await request.get<ApiResult<HjmChoices>>(
    '/hjm/hjm-choices/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
